/*

   A new feature added to HMG in the 3.1.4 version: Control level context menu.

   This is a demo prg for this good and important emhancement; 
   with big thanks and best regards to Dr. Soto.
   
   This demo builded upon fomus HMG demo : Main.Demo.
   
   Happy HMG'ing :D
   
   Esgici ( 2013.6.22 )
   
*/

#include <hmg.ch>

PROCEDURE Main()

	aRows := { { '', 'Simpson','Homer'},;
	          { '', 'Mulder','Fox'},; 
	          { '', 'Smart','Max'},; 
	          { '', 'Grillo','Pepe'},; 
	          { '', 'Kirk','James'},; 
	          { '', 'Barriga','Carlos'},; 
	          { '', 'Flanders','Ned'},; 
	          { '', 'Smith','John'},; 
	          { '', 'Lopez','Roberto'},;
	          { '', 'Gomez','Juan'},; 
	          { '', 'Fernandez','Raul'},; 
	          { '', 'Borges','Javier'},; 
	          { '', 'Alvarez','Alberto'},; 
	          { '', 'Gonzalez','Ambo'},; 
	          { '', 'Batistuta','Gol'},; 
	          { '', 'Vinazzi','Amigo'},; 
	          { '', 'Pedemonti','Flavio'},; 
	          { '', 'Samarbide','Armando'},; 
	          { '', 'Pradon','Alejandra'},; 
	          { '', 'Reyes','Monica'} }
   
	SET TOOLTIPSTYLE BALLOON

	DEFINE WINDOW frmCLCMDemo ;
		AT 0,0 ;
		WIDTH 640 HEIGHT 490 ;
		TITLE 'HMG Control Level Contex Menu Demo' ;
		ICON 'DEMO.ICO' ;
		MAIN
      
      ON KEY ESCAPE ACTION ThisWindow.Release
      
      DEFINE MAIN MENU 
			DEFINE POPUP '&File'
				ITEM 'More Tests'	 NAME File_Modal   ACTION MsgInfo ( "File\More Tests Clicked" ) 	
				ITEM 'Topmost Window' NAME File_TopMost ACTION MsgInfo ( "File\Topmost Window Clicked" )  
			END POPUP
			DEFINE POPUP 'H&elp'
				ITEM 'About'		      ACTION MsgInfo ("Free GUI Library For Harbour","HMG Main Demo") 
			END POPUP
		END MENU // MAIN
		      
		DEFINE CONTEXT MENU 
			ITEM 'Check File - More Tests Item'	   ACTION Context1_Click()
			ITEM 'UnCheck File - More Test Item'	   ACTION Context2_Click() 
			ITEM 'Enable File - Topmost Window'  	ACTION Context3_Click()
			ITEM 'Disable File - Topmost Window'	ACTION Context4_Click()
			SEPARATOR	
			ITEM 'About'				ACTION MsgInfo ("Free GUI Library For Harbour","HMG Main Demo") 
		END MENU // CONTEXT
      
		DEFINE TAB Tab_1 ;
			AT 45, 25 ;
			WIDTH 580 ;
			HEIGHT 340 ;
			VALUE 1 ;
			TOOLTIP 'Tab Control' 

			DEFINE PAGE '&Grid'

				DEFINE GRID Grid_1
					ROW	30
					COL	10
					WIDTH 550 
					HEIGHT 300 
					HEADERS { '','Last Name','First Name'} 
					WIDTHS { 0,220,220}
					ITEMS aRows 
					VALUE 1 
					TOOLTIP 'Right clik for GRID context menu' 
					ONHEADCLICK { {|| MsgInfo('Header 1 Clicked !')} , { || MsgInfo('Header 2 Clicked !')} } 
					IMAGE {"br_no","br_ok"} 
					ONDBLCLICK MsgInfo ('DoubleClick!','Grid') 
				END GRID

			END PAGE

			DEFINE PAGE '&Misc.'

				DEFINE FRAME TabFrame_1
					ROW	45
					COL	80
				   WIDTH 130
					HEIGHT 130
				END FRAME

				DEFINE LABEL Label_1
					ROW 	55
					COL	90
					VALUE '&This is a Label !!!' 
					WIDTH 100 
					HEIGHT 27 
				END LABEL

				DEFINE CHECKBOX Check_1
					ROW	80
					COL	90
					CAPTION 'Check 1' 
					VALUE .T. 
					TOOLTIP 'CheckBox' 
					ONCHANGE PLAYOK()
				END CHECKBOX

				DEFINE SLIDER Slider_1
					ROW	115
					COL	85
					RANGEMIN 1
					RANGEMAX 10 
					VALUE 5 
					TOOLTIP 'Right click for SLIDER context menu'
				END SLIDER
				
				DEFINE FRAME TabFrame_2
					ROW	45
					COL	240
					WIDTH 125 
					HEIGHT 130 
				END FRAME

				DEFINE RADIOGROUP Radio_1
					ROW	50
					COL	260
					OPTIONS { 'One' , 'Two' , 'Three', 'Four' } 
					VALUE 1 
					WIDTH 100 
					TOOLTIP 'Right Click for RADIOGROUP context menu'
					ONCHANGE PLAYOK() 
				END RADIOGROUP

			END PAGE

			DEFINE PAGE '&EditBox'

				DEFINE EDITBOX Edit_1
					ROW	30
					COL	10
					WIDTH 550 
					HEIGHT 300 
					VALUE 'EditBox!!' 
					TOOLTIP 'Right click for EDITBOX Context menu' 
					MAXLENGTH 255 
				END EDITBOX

			END PAGE

			DEFINE PAGE '&ProgressBar'

				DEFINE PROGRESSBAR Progress_1
					ROW	80
					COL	120
					RANGEMIN 0
					RANGEMAX 65535		
				END PROGRESSBAR
				
				DEFINE BUTTON Btn_Prg
					ROW	80
					COL	250
					CAPTION '<- !!!' 
					ACTION Animate_CLick() 
					WIDTH 50 
					HEIGHT 28 
					TOOLTIP 'Animate Progressbar'
				END BUTTON

			END PAGE

		END TAB    
      
      DEFINE CONTROL CONTEXTMENU Grid_1
			ITEM 'Get grid value'	   ACTION MsgInfo( LTRIM( STR( frmCLCMDemo.Grid_1.Value ) ) )
			ITEM 'Set grid value'	   ACTION frmCLCMDemo.Grid_1.Value := 5
      END MENU
      
      DEFINE CONTROL CONTEXTMENU Edit_1
      /*
         This not works !
         Because EDITBOX has their own context menu
      */
			ITEM 'Get EDITBOX value'	   ACTION MsgInfo( frmCLCMDemo.Edit_1.Value )
			ITEM 'Set EDITBOX value'	   ACTION frmCLCMDemo.Edit_1.Value := "New EDITBOX value" 
      END MENU
      
      DEFINE CONTROL CONTEXTMENU Radio_1
			ITEM 'Get RADIOGROUP value'	   ACTION MsgInfo( LTRIM( STR( frmCLCMDemo.Radio_1.Value ) ) )
			ITEM 'Set RADIOGROUP value'	   ACTION frmCLCMDemo.Radio_1.Value := 1
      END MENU
      
      DEFINE CONTROL CONTEXTMENU Slider_1
			ITEM 'Get SLIDER value'	   ACTION MsgInfo( LTRIM( STR( frmCLCMDemo.Slider_1.Value ) ) )
			ITEM 'Set SLIDER value'	   ACTION frmCLCMDemo.Slider_1.Value := 1
      END MENU
      
      DEFINE STATUSBAR OF frmMain FONT 'Verdana' SIZE 8
			STATUSITEM 'Right click for FORM Context Menu in OUT of controls has Context Menu' 
         DATE WIDTH 80
         CLOCK WIDTH 90
      END STATUSBAR      
      
	END WINDOW

	CENTER WINDOW frmCLCMDemo

	ACTIVATE WINDOW frmCLCMDemo

RETURN // Main()

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

PROCEDURE Context1_Click

	frmCLCMDemo.File_Modal.Checked := .T.
	MsgInfo ("File - More Tests Checked")

RETURN // Context1_Click

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

PROCEDURE Context2_Click

	frmCLCMDemo.File_Modal.Checked := .F.
	MsgInfo ("File - Modal Window Unchecked")

RETURN // Context2_Click

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

PROCEDURE Context3_Click

	frmCLCMDemo.File_Topmost.Enabled := .T.
	MsgInfo ("File - Topmost Window Enabled")

RETURN // Context3_Click

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

PROCEDURE Context4_Click

	frmCLCMDemo.File_Topmost.Enabled := .F.
	MsgInfo ("File - Topmost Window Disabled")

RETURN // Context4_Click

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

PROCEDURE Animate_CLick

LOCAL i

	For i = 0 To 65535 Step 25
		frmCLCMDemo.Tab_1(4).Progress_1.Value := i
	Next i

RETURN // Animate_CLick

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.
